<?php
/*
Plugin Name: Experts-Exchange Badge
Plugin URI: http://hiremasonwolf.com
Description: Have your experts-exchange ranking displayed for all your blog visitors in a nice little graphic. Requires a width of 224 px. Can be used as a sidebar widget or by editing your sidebar.php file directly and including a call to "eebadge([your profile number]);" Your profile number is the one that completes the link to your experts-exchange member profile: "http://www.experts-exchange.com/M_#######.html".
Author: MasonWolf
Version: 1.0
Author URI: http://hiremasonwolf.com/
*/
function ee_badge($profile)
{
$page = file_get_contents("http://www.experts-exchange.com/M_$profile.html");
preg_match('@<span>([0-9]{1,3}(?:,[0-9]{3})*)</span>\s+Expert Points@', $page, $points);
preg_match('@<span>([0-9]{2}/[0-9]{2}/[0-9]{4})</span>\s+Registration Date@', $page, $date);
preg_match('@<span>([[:alnum:]]+)</span>\s+Login Name@', $page, $name);
if((int)str_replace(",","",$points[1]) < 50000) $bg_img = "rookie1.png";
elseif((int)str_replace(",","",$points[1]) < 150000) $bg_img = "master1.png";
elseif((int)str_replace(",","",$points[1]) < 300000) $bg_img = "guru1.png";
elseif((int)str_replace(",","",$points[1]) < 500000) $bg_img = "wizard1.png";
elseif((int)str_replace(",","",$points[1]) < 1000000) $bg_img = "sage1.png";
elseif((int)str_replace(",","",$points[1]) < 10000000) $bg_img = "genius1.png";
elseif((int)str_replace(",","",$points[1]) < 25000000) $bg_img = "savant1.png";
elseif((int)str_replace(",","",$points[1]) < 50000000) $bg_img = "elite1.png";
elseif((int)str_replace(",","",$points[1]) < 100000000) $bg_img = "technocrat1.png";
else $bg_img = "legend1.png";
?>
<div style="width:224px"><div style="background:url('<?= str_replace(ABSPATH, '', dirname(__FILE__)).'/'.$bg_img;?>') no-repeat top left #EEEEEE; height:110px; cursor:pointer; border:ridge orange 3px" align="center" onClick="window.open('http://www.experts-exchange.com/M_4228713.html')">
<strong style="font-size:9px; color:#999; font-family:Verdana, Arial, Helvetica, sans-serif">EXPERTS-EXCHANGE.COM CERTIFIED</strong>
<div align="center" style="width:120px; margin-left:85px; margin-top:32px; margin-right:25px">
<span style="font-family:'Times New Roman'; color: #ff6633;font-size: 14px; display: block; font-weight: bold; white-space: normal;"><?=$name[1];?></span>
<span style="font-family:'Times New Roman'; font-weight:bold; color:#666666; font-size:14px"><?=$points[1];?> POINTS</span>
</div>
<div style="margin-top:10px">
<span style="display: block; font-family:'Times New Roman'; font-weight:bold; color:#999999; font-size:10px; margin-bottom:0">MEMBER SINCE <?=$date[1];?></span>
</div>
</div><p style="font-size:x-small" align="center"><a href="http://hiremasonwolf.com/?p=31" target="_blank">EE-certified? Get your own badge!</a></p>
</div>
<?php
}
function widget_eebadge_init() {
	if (!function_exists('register_sidebar_widget')) {
		return;
	}
function widget_eebadge($args) {
    extract($args);
 echo $before_widget . $before_title . $after_title; 
$profile = get_option('widget_eebadge');
ee_badge($profile[0]);
 echo $after_widget;
}
function widget_eebadge_options()
{
	$profile = get_option('widget_eebadge');
	$profile = $profile[0];
	if($_POST['eebadge-submit'])
	{
		if(ereg('[0-9]{4,7}',$_POST['eebadge-profile']))
		{
			update_option('widget_eebadge', array($_POST['eebadge-profile']));
			$profile = $_POST['eebadge-profile'];
		}
		else
		{
			echo "<p style='font-weight:bold;'><span style='color:red'>Invalid link:</span> The profile link provided should be between 4 and 7 digits and may only contain numbers. Please enter a valid code</p>";
		}
	}
	echo '<p>Complete the link to your EE profile:<br>http://www.experts-exchange.com/M_<input type="text" name="eebadge-profile" value="'.$profile.'" id="eebadge-profile" />.html'."\n";
	echo '<input type="hidden" id="eebadge-submit" name="eebadge-submit" value="1" />'."\n";
}
register_sidebar_widget('Experts Exchange Badge','widget_eebadge');
register_widget_control('Experts Exchange Badge','widget_eebadge_options', 500, 50);
}

add_action('plugins_loaded', 'widget_eebadge_init');
?>